#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=sentinel.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Change2CUI=y
#Au3Stripper_Parameters=/sv /sf
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; =======================================================================================
; Title .........: Backup
; Description ...: Save and Safe data
; Requirement(s).: compatible Autoit v3.3.14.2
; Author(s) .....: Giovanni Rossati (El Condor)
; Version........: 0.2.0
; Date...........: 13 January 2018
; =======================================================================================
#include <APIShellExConstants.au3>
#include <WinAPI.au3>
#include <WinAPIShellEx.au3>
#include <WinAPIFiles.au3>
#include <File.au3>
#include <Crypt.au3>
#include "formGen.au3"
#Include <Array.au3>
Opt('TrayAutoPause', 0)
OnAutoItExitRegister('Deregister')
Global $fileDict = ObjCreate("Scripting.Dictionary")   ; Create a Scripting Dictionary for memorize files guarded
; the key is the fileName to backup (with path), the value is an array containing:
;		origin folder
; 		backup file (complete path)
;		possibly encryption password
;		handle returned by _WinAPI_ShellUPDATENOTIFYRegister
;		fileName
TraySetIcon()	; show the program ico
; form parameters ******************************************************
$records = "" _
	& "//F,File,File to guard,40,C:\Users\User\Documents\backup.doc;" _
	& "F,File,File to guard,40,C:\citazioni.txt;" _
	& "Required,File;" _
	& "D,Folder,Folder to save,30,C:\Dropbox\backup;" _
	& "Required,Folder;" _
	& "T,Password,Password,20,,;" _
	& "Control,Password,pattern=.{8\44};" _
	& "Tooltip,Password,If crypt requested input almost 8 characters;" _
	& "CKB,runProgram,Run application,,1;" _
	& "BL,Ok,Guard,,,Run and start guard,genGuard;" _
	& "C,separator,-;" _
	& "F,FileR,File to restore,40,C:\Dropbox\backup\;" _
	& "Required,FileR;" _
	& "D,FolderR,Folder to save,30,C:\Users\User\Documents;" _
	& "Required,FolderR;" _
	& "T,PasswordR,Password,20,,;" _
	& "Control,PasswordR,pattern=.{8\44};" _
	& "Tooltip,PasswordR,If the file is encrypted almost 8 characters;" _
	& "BL,Restore,Restore,,,Restore the file,Restore;" _
	& "Menu,File,&File;" _
	& "SubMenu,Showguard,&Show guarded,Showguard;" _
	& "SubMenu,Exit,&Exit,EndProgram;" _
	& "Menu,About,&About;" _
	& "SubMenu,sAbout,&About,About;"
$aReturn = formGen("BackUp",$records,-1,"checkEvents")
msgbox(0,"","See you later alligator",1.5)
; ********************************** guard ******************************************
Func genGuard($data)
	Local $sDrive = "", $sDir = "", $sExtension = "", $Path = "", $file = ""
	$psw = $data.item("Password")
	$fileToGuard = $data.item("File")
	Local $aPathSplit = _PathSplit($fileToGuard, $sDrive, $Path, $File, $sExtension)
	$destFolder = $data.item("Folder")
	if StringRight($destFolder,1) <> "\" then $destFolder = $destFolder & "\"
	$Path = $sDrive & $Path
	Local $dataFile[] = [$Path,$destFolder,$psw, 0,$File & $sExtension]
;	if $data.item("runProgram") = "1" Then Run(@comspec & ' /c start "" "' & $data.item("File") &  '"','',@SW_MAXIMIZE)
	if $data.item("runProgram") = "1" Then ShellExecute($data.item("File"),@SW_MAXIMIZE)
	if isNewFolder($Path) Then
		Local $iMsg = _WinAPI_RegisterWindowMessage('UPDATENOTIFY' & $fileDict.count)
		GUIRegisterMsg($iMsg, 'WM_UPDATENOTIFY')	; the message is associated to function WM_UPDATENOTIFY
		$dataFile[3] =  _WinAPI_ShellChangeNotifyRegister($data.item("fg_winhandle"), _
						$iMsg, _
						$SHCNE_UPDATEITEM, _	; guard update file system
						BitOR($SHCNRF_INTERRUPTLEVEL, $SHCNRF_SHELLLEVEL, $SHCNRF_RECURSIVEINTERRUPT), _
						$Path)
		If @error Then
			MsgBox(BitOR($MB_ICONERROR, $MB_SYSTEMMODAL),'Error','Window does not registered.')
			Exit
		EndIf
	EndIf
	ConsoleWrite("Folder " & $path & " guarded" & @CRLF)
	$fileDict.Item($fileToGuard) = $dataFile
EndFunc
Func WM_UPDATENOTIFY($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg
	Local $sPath = _WinAPI_ShellGetPathFromIDList(DllStructGetData(DllStructCreate('dword Item1; dword Item2', $wParam), 'Item1'))
	If $sPath Then
		if $fileDict.Exists($sPath) Then		; a file has been updated
			Local $dataFile = $fileDict.Item($sPath)
			If $dataFile[2] = "" Then		; there is a password?
				FileCopy($sPath,$dataFile[1], $FC_OVERWRITE + $FC_CREATEPATH)
			Else
				_Crypt_EncryptFile($sPath, $dataFile[1] & $dataFile[4], $dataFile[2],$CALG_AES_192)	; Encrypt the file.
				If @error <> 0 Then
					consoleWrite("Error when encrypting: " & @error & @CRLF)
				EndIf
			EndIf
			consoleWrite($sPath & " saved")
			if $dataFile[2] <> "" Then ConsoleWrite(" and encrypted")
			ConsoleWrite(@CRLF)
		Else
;			ConsoleWrite('Event: 0x' & Hex($lParam) & @CRLF & $sPath & @CRLF)
		EndIf
	EndIf
EndFunc   ;==>WM_UPDATENOTIFY
Func isNewFolder($p)	; check if the folder is just in control
	For $key in $fileDict
		$itemGuard = $filedict.item($key)
		If $itemGuard[0] = $p then return false
	Next
	return true
EndFunc
Func showGuard()
	$aDict = getIniFormat($fileDict)
	Local $iOrgWidth = 500, $iHeight = 300
	Local $hGUI = GUICreate("Files on guard", $iOrgWidth, $iHeight)
	Local $aiGUISize = WinGetClientSize($hGUI)
	Local $idListview = GUICtrlCreateListView(StringFormat("File   %40s |Folder %40s |Encript key","",""), 10, 10, 480, 240)
	For $i=1 to $aDict[0][0]
		$a = $aDict[$i][1]
		Local $idItem = GUICtrlCreateListViewItem($aDict[$i][0] & "|" & $a[1] & "|"  & $a[2],$idListview)
	Next
	GUISetState(@SW_SHOW, $hGUI)
    While 1
        Switch GUIGetMsg()
            Case $GUI_EVENT_CLOSE
                ExitLoop
        EndSwitch
    WEnd
	GUIDelete()
EndFunc
Func Restore($data)
	$psw = $data.item("PasswordR")
	$fileToRestore = $data.item("FileR")
	Local $sDrive = "", $sDir = "", $sExtension = "", $Pth = "", $file
	Local $aPathSplit = _PathSplit($fileToRestore, $sDrive, $Pth, $File, $sExtension)
	$File = $File & $sExtension
	$destFile = $data.item("FolderR")
	if StringRight($destFile,1) <> "\" then $destFile = $destFile & "\"
	$destFile = $destFile & $File
	if $psw = "" Then
		FileCopy($fileToRestore,$destFile, $FC_OVERWRITE + $FC_CREATEPATH)
	Else
		_Crypt_DecryptFile($fileToRestore, $destFile, $psw,$CALG_AES_192)	; Decrypt the file.
	EndIf
	msgbox(0,"Restore",$fileToRestore,1.5)
	ConsoleWrite("Restored file " & $fileToRestore & " from " & $Pth & @CRLF)
EndFunc
Func checkEvents($msg)		; callback function
	$name = widgetName($msg)
	if $name = "runProgram" Then
		$value = GUICtrlRead(widgetID("runProgram"))
		if $value = "1" Then
			ControlSetText("", "", "[TEXT:Start guard]" ,"Run and start guard")
		Else
			ControlSetText("", "", "[TEXT:Run and start guard]" ,"Start guard")
		endif
	EndIf
EndFunc
Func About()
	MsgBox(0, "Credits", "Condor Informatique - Turin" _
			& @CRLF & "www.condorinformatique.com"	_
			& @CRLF & @CRLF & "Backup"	_
			& @CRLF & "Version 0.2.0 13 January 2018" _
			& @CRLF & "Program developped with AutoIt3 v3.3.14.2")
EndFunc   ;==>OnAutoItExit
Func Deregister()
	For $key in $fileDict
		$itemGuard = $filedict.item($key)
		$g_iID = $itemGuard[3]
		If $g_iID Then _WinAPI_ShellChangeNotifyDeregister($g_iID)
	Next
EndFunc   ;==>OnAutoItExit
func EndProgram()
	MsgBox(0,"","See you later alligator",1)
	exit
EndFunc